var teletypeGadget = new TeletypeGadget();
var rss = null;


function PrepareControlCore(path, rootCls, rootPid, rootTypeLib, clsid, prgid, dllname, name, typelib)
{
    var wshShell = new ActiveXObject("WScript.Shell"); 
    
    wshShell.RegWrite (rootPid, name);
    wshShell.RegWrite (rootPid+"CLSID\\", "{"+clsid+"}");
    wshShell.RegWrite (rootCls, prgid);
    wshShell.RegWrite (rootCls+"InprocServer32\\", path);
    wshShell.RegWrite (rootCls+"InprocServer32\\ThreadingModel", "Apartment");
    wshShell.RegWrite (rootCls+"Implemented Categories\\{7DD95801-9882-11CF-9FA9-00AA006C42C4}\\", "");
    wshShell.RegWrite (rootCls+"Implemented Categories\\{7DD95802-9882-11CF-9FA9-00AA006C42C4}\\", "");   
    
    wshShell.RegWrite (rootCls+"MiscStatus\\1\\", "131473");     
    wshShell.RegWrite (rootCls+"Control\\", "");
    wshShell.RegWrite (rootCls+"Insertable\\", "");
    wshShell.RegWrite (rootCls+"Programmable\\", "");  
    wshShell.RegWrite (rootCls+"VersionIndependentProgID\\", "prgid");  
    wshShell.RegWrite (rootCls+"TypeLib\\", "{"+typelib+"}");  
    
    wshShell.RegWrite (rootTypeLib, name+" 1.0 Type Library");
    wshShell.RegWrite (rootTypeLib+"0\\win32\\", path);  
    wshShell.RegWrite (rootTypeLib+"FLAGS\\", "0");  
    wshShell.RegWrite (rootTypeLib+"HELPDIR\\", path);  
}

function PrepareControl(path, clsid, prgid, dllname, name, typelib)
{
    var rootCls = "HKCU\\Software\\Classes\\CLSID\\{" + clsid + "}\\";
    var rootPid = "HKCU\\SOFTWARE\\Classes\\" + prgid + "\\";
    var rootTypeLib =  "HKCU\\SOFTWARE\\Classes\\TypeLib\\{" + typelib + "}\\1.0\\";
    try{
    PrepareControlCore(path, rootCls, rootPid, rootTypeLib, clsid, prgid, dllname, name, typelib);
    }catch(e){}
   
    rootCls = "HKLM\\Software\\Classes\\CLSID\\{" + clsid + "}\\";
    rootPid = "HKLM\\SOFTWARE\\Classes\\" + prgid + "\\";
    rootTypeLib =  "HKLM\\SOFTWARE\\Classes\\TypeLib\\{" + typelib + "}\\1.0\\";
    try{
    PrepareControlCore(path, rootCls, rootPid, rootTypeLib, clsid, prgid, dllname, name, typelib);
    }catch(e){} 
}

function TeletypeGadget() {

var path = gadget.storage.extract("NewsByKeywords.dll");

PrepareControl(path, "8E7F4CE7-419B-4C1D-B816-E175153EDAC2", "NewsByKeywords.NewsByKeywordsGadget",
	"NewsByKeywords.dll", "NewsByKeywords", "748F8B4C-DD29-4B73-9FDF-5B9810DC9F44");
PrepareControl(path, "80FDB99B-8B73-4447-8DC3-B7F6DE58AF18", "NewsByKeywords.NewsByKeywordsPropPage",
	"NewsByKeywords.dll", "NewsByKeywordsPropPage", "748F8B4C-DD29-4B73-9FDF-5B9810DC9F44");
}

TeletypeGadget.prototype.onOpen = function() {
var ObjXML = "<object classId=\"clsid:8E7F4CE7-419B-4C1D-B816-E175153EDAC2\" name=\"RSST\" height=\"100%\" width=\"100%\" cursor=\"hand\" tooltip=\"&GADGET_TIP_TEXT;\"></object>";
view.appendElement(ObjXML);
	try{
		if(RSST.object == null){
			view.alert(COULDNT_LOAD_ACTIVEX);
			return;
		}
		rss = RSST.object;
		rss.SetLanguage(LANG);
		rss.LoadSettings();
	}catch(e){
			view.alert(COULDNT_LOAD_ACTIVEX);
			return;
	}
	plugin.onAddCustomMenuItems = TeletypeGadget.addCustomMenuItems;
};

TeletypeGadget.prototype.onClose = function() {
//	delete rss;
rss = null;
};

TeletypeGadget.prototype.onMouseOver = function() {

};

TeletypeGadget.prototype.onClick = function() {
	rss.OpenCurrentLink();
};


TeletypeGadget.addCustomMenuItems = function(menu) {
	menu.AddItem(GADGET_MENU_PAUSE, rss.Paused ? gddMenuItemFlagChecked : 0, TeletypeGadget.pauseGadget);
	menu.AddItem(GADGET_MENU_OPTIONS, 0, TeletypeGadget.showOptions);
if(!rss.Registered)
	menu.AddItem(GADGET_MENU_REGISTER, 0, TeletypeGadget.registerGadget);
};

TeletypeGadget.pauseGadget = function() { 
	rss.Pause();
};

TeletypeGadget.showOptions = function() { 
	rss.ShowSettings();
	rss.SaveSettings();
};

TeletypeGadget.registerGadget = function() { 
	rss.RegisterGadget();
};